> For the complete documentation index, see [llms.txt](https://docs.defguard.net/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.defguard.net/2.1/for-developers/rest-api/core/group/assign-multiple-users-to-multiple-groups.md).

# Assign multiple users to multiple groups

```json
{"openapi":"3.1.0","info":{"title":"defguard Core API","version":"2.1.0"},"tags":[{"name":"group","description":"User groups and their members."}],"security":[{"cookie":[]},{"api_token":[]}],"components":{"securitySchemes":{"cookie":{"type":"apiKey","in":"cookie","name":"defguard_session"},"api_token":{"type":"http","scheme":"bearer"}},"schemas":{"BulkAssignToGroupsRequest":{"type":"object","required":["groups","users"],"properties":{"groups":{"type":"array","items":{"type":"string"}},"users":{"type":"array","items":{"$ref":"#/components/schemas/i64"}}}},"i64":{"type":"integer","format":"int64"},"ApiErrorResponse":{"type":"object","description":"Body returned with error responses.","required":["msg"],"properties":{"code":{"type":["string","null"],"description":"Machine-readable error code, returned for selected errors."},"msg":{"type":"string","description":"Human-readable error message."}}}}},"paths":{"/api/v1/groups-assign":{"post":{"tags":["group"],"summary":"Assign multiple users to multiple groups","operationId":"bulk_assign_to_groups","requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/BulkAssignToGroupsRequest"}}},"required":true},"responses":{"200":{"description":"Users assigned to the groups."},"400":{"description":"The request contains unknown users or groups.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiErrorResponse"}}}},"401":{"description":"Session is missing or invalid.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiErrorResponse"}}}},"403":{"description":"Requires admin privileges.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiErrorResponse"}}}},"500":{"description":"Unable to assign users.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ApiErrorResponse"}}}}}}}}}
```
